#ifndef _yj901s_H_
#define _yj901s_H_

#include "main.h"

typedef enum
{
    ACC = 0x51,
    ANG_VEL,
    ANGLE,
    MAG,
}yj901s_state_e;

#pragma anon_unions
#pragma pack(1)  

typedef struct
{
    int16_t accX;
    int16_t accY;
    int16_t accZ;
    int16_t angVelX;
    int16_t angVelY;
    int16_t angVelZ;
    int16_t angle_roll;
    int16_t angle_pitch;
    int16_t angle_yaw;
    int16_t magX;
    int16_t magY;
    int16_t magZ;
}yj901s_space_s;

typedef struct
{
    union
    {
        yj901s_space_s yj901s_data;
        uint8_t data[YJ901S_DATA_SIZE];
    };
}yj901s_s;
#pragma pack ()

void yj901s_parse(uint8_t *data, uint8_t len);
void set_sensor(uint8_t flag, uint8_t *data);
void yj901s_get(uint8_t cmd, uint8_t *data);

extern yj901s_s yj901s_data_buffer;

extern uint8_t can1_sensor[3];
extern uint8_t can2_sensor[3];

#endif // !_yj901s_H_
