#include "yj901s.h"
#include "utils.h"
#include "string.h"

yj901s_s yj901s_data_buffer;

uint8_t can1_sensor[3] = {0};
uint8_t can2_sensor[3] = {0};

uint8_t yj901s_calculate_checksum(uint8_t *data, uint8_t len);


void yj901s_parse(uint8_t *data, uint8_t len)
{
    if(data[len-1] != yj901s_calculate_checksum(data, len))
    {
        return;
    }
    switch (data[1])
    {
    case ACC:
        memcpy(yj901s_data_buffer.data, &data[2], 6);
        break;
    case ANG_VEL:
        memcpy(&yj901s_data_buffer.data[6], &data[2], 6);
        break;
    case ANGLE:
        memcpy(&yj901s_data_buffer.data[12], &data[2], 6);
        break;
    case MAG:
        memcpy(&yj901s_data_buffer.data[18], &data[2], 6);
        break;
    default:
        break;
    }

}

void set_sensor(uint8_t flag, uint8_t *data)
{
    if(flag == 0x01)
    {
        memcpy(can1_sensor, data, 3);
    }
    else if(flag == 0x02)
    {
        memcpy(can2_sensor, data, 3);
    }
}

void yj901s_get(uint8_t cmd, uint8_t *data)
{
    if(cmd == 0x01)
    {
        data[0] = 0x11;
        memcpy(&data[1], yj901s_data_buffer.data, 12);
        memcpy(&data[13], can1_sensor, 3);
    }
    else if(cmd == 0x02)
    {
        data[0] = 0x12;
        memcpy(&data[1], &yj901s_data_buffer.data[12], 12);
        memcpy(&data[13], can2_sensor, 3);
    }
}

uint8_t yj901s_calculate_checksum(uint8_t *data, uint8_t len)
{
    uint8_t checksum = 0;
    for(uint8_t i = 0; i < len - 1; i++)
    {
        checksum += data[i]; 
    }
    return checksum;
}
